/**
 * Namespace.java
 *
 * File generated from the XValidator::Namespace uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import org.w3c.dom.Node;

/**
 * Description of the class Namespace.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Namespace", propOrder = { "prefix", "uri" })
@XmlRootElement(name = "Namespace")
@Entity
@Table(name = "xval_namespace", schema = "public")
@SequenceGenerator(name = "xval_namespace_sequence", sequenceName = "xval_namespace_id_seq", allocationSize = 1)
public class Namespace implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@XmlTransient
	@GeneratedValue(generator = "xval_namespace_sequence", strategy = GenerationType.SEQUENCE)
	@Column(name = "id", unique = true, nullable = false)
	private Integer id;

	@XmlAttribute(name = "prefix", required = true)
	@Column(name = "prefix")
	private String prefix;
	@XmlAttribute(name = "uri", required = true)
	private String uri;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	public Namespace(String inPrefix, String inUri) {
		super();
		this.prefix = inPrefix;
		this.uri = inUri;
	}

	public Namespace() {
		super();
	}

	/**
	 * Return prefix.
	 * 
	 * @return prefix
	 */
	public String getPrefix() {
		return prefix;
	}

	/**
	 * Set a value to attribute prefix.
	 * 
	 * @param prefix
	 *            .
	 */
	public void setPrefix(String prefix) {
		this.prefix = prefix;
	}

	/**
	 * Return uri.
	 * 
	 * @return uri
	 */
	public String getUri() {
		return uri;
	}

	/**
	 * Set a value to attribute uri.
	 * 
	 * @param uri
	 *            .
	 */
	public void setUri(String uri) {
		this.uri = uri;
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "Namespace", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result) + ((prefix == null) ? 0 : prefix.hashCode());
		result = (prime * result) + ((uri == null) ? 0 : uri.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		Namespace other = (Namespace) obj;
		if (prefix == null) {
			if (other.prefix != null) {
				return false;
			}
		} else if (!prefix.equals(other.prefix)) {
			return false;
		}
		if (uri == null) {
			if (other.uri != null) {
				return false;
			}
		} else if (!uri.equals(other.uri)) {
			return false;
		}
		return true;
	}
	
	@Override
	public String toString(){
		StringBuilder builder = new StringBuilder("xmlns:");
		builder.append(prefix);
		builder.append(" = ");
		builder.append(uri);
		return builder.toString();
	}
	
	public boolean isValid(){
		boolean prefixValid = prefix != null && !prefix.isEmpty();
		boolean uriValid = uri != null && !uri.isEmpty();
		return prefixValid && uriValid;
	}

}